unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    TrackBar1: TTrackBar;
    Timer1: TTimer;
    TrackBar2: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  g = 10;   { przyspieszenie ziemskie }
  dh = 0.1; { jeden piksel w wysokosci to dh metrow }
  ddt = 0.01; { jedna podzialka na skali to tyle sekund fizycznych }
  dint = 10; { jedna podzialka na skali to tyle milisekund systemowych }
  board_x1 = 40;
  board_y1 = 10;
  board_x2 = 340;
  board_y2 = 410;
  r = 5; { promien kulki w pikselach }
  max_h = board_y2 - board_y1 - r;
  h0 = r*dh;

var
  dt: Real; { kwant czasu }

type
  TKulka = class
    v, h: Real;
    x: Integer;
  public
    constructor Create(ah: Integer; ax: Integer);
    function get_h: Integer;
    function get_x: Integer;
    procedure krok;
  end;

var kulka : TKulka = nil;

constructor TKulka.Create(ah: Integer; ax: Integer);
begin
  x := ax;
  h := ah*dh;
  v := 0.0;
end;

function TKulka.get_h;
var res: Integer;
begin
  res := Round(h/dh);
  if res <= r
    then get_h := r
  else if res >= max_h
    then get_h := max_h
  else get_h := res
end;

function TKulka.get_x;
begin
  get_x := x
end;

procedure TKulka.krok;
begin
  if h <= h0
    then v := -v;
  v := v + (g*dt)/2;
  h := h - (v*dt);
  v := v + (g*dt)/2;
end;

procedure RysujPlansze;
begin
  Form1.Canvas.Brush.Color := $00FFFFFF;
  Form1.Canvas.Pen.Color := $00000000;
  Form1.Canvas.Rectangle(board_x1, board_y1, board_x2, board_y2);
end;

procedure RysujKulke;
  var x, y: Integer;
begin
  if kulka <> nil then begin
    x := board_x1 + kulka.get_x;
    y := board_y2 - kulka.get_h;
    Form1.Canvas.Pen.Color := $00FF0000;
    Form1.Canvas.Brush.Color := $00FF0000;
    Form1.Canvas.Ellipse(x-r, y-r, x+r, y+r);
  end
end;

procedure KasujKulke;
  var x, y: Integer;
begin
  if kulka <> nil then begin
    x := board_x1 + kulka.get_x;
    y := board_y2 - kulka.get_h;
    Form1.Canvas.Pen.Color := $00FFFFFF;
    Form1.Canvas.Brush.Color := $00FFFFFF;
    Form1.Canvas.Ellipse(x-r, y-r, x+r, y+r);
  end
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  RysujPlansze;
  RysujKulke;
end;


procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Timer1.Enabled := false;
  if (X >= board_x1+r) and (X <= board_x2-r) and
    (Y >= board_y1+r) and (Y <= board_y2-r)
  then begin
    if kulka <> nil
      then begin
        KasujKulke;
        kulka.Destroy;
      end;
    kulka := TKulka.Create(board_y2 - Y, X - board_x1);
    RysujKulke;
  end
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Timer1.Enabled := true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if kulka <> nil then begin
    KasujKulke;
    kulka.krok;
    RysujKulke;
  end
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  dt := 0.1;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  dt := ddt * TTrackBar(Sender).Position
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  Timer1.Interval := dint * (TTrackBar(Sender).Position+1)
end;

end.
